    001    /* ========================================================================
    002     * JCommon : a free general purpose class library for the Java(tm) platform
    003     * ========================================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jcommon/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * -------------------
    028     * AnnualDateRule.java
    029     * -------------------
    030     * (C) Copyright 2000-2003, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * $Id: AnnualDateRule.java,v 1.3 2005/10/18 13:15:08 mungady Exp $
    036     *
    037     * Changes (from 26-Oct-2001)
    038     * --------------------------
    039     * 26-Oct-2001 : Changed package to com.jrefinery.date.* (DG);
    040     * 12-Nov-2001 : Javadoc comments updated (DG);
    041     * 03-Oct-2002 : Fixed errors reported by Checkstyle (DG);
    042     *
    043     */
    044
    045    package org.jfree.date;
    046
    047    /**
    048     * The base class for all 'annual' date rules: that is, rules for generating
    049     * one date for any given year.
    050     * <P>
    051     * One example is Easter Sunday (which can be calculated using published algorithms).
    052     *
    053     * @author David Gilbert
    054     */
    055    public abstract class AnnualDateRule implements Cloneable {
    056
    057        /**
    058         * Default constructor.
    059         */
    060        protected AnnualDateRule() {
    061        }
    062
    063        /**
    064         * Returns the date for this rule, given the year.
    065         *
    066         * @param year  the year (1900 &lt;= year &lt;= 9999).
    067         *
    068         * @return the date for this rule, given the year.
    069         */
    070        public abstract SerialDate getDate(int year);
    071
    072        /**
    073         * Returns a clone of the rule.
    074         * <P>
    075         * You should refer to the documentation of the clone() method in each
    076         * subclass for exact details.
    077         *
    078         * @return a clone of the rule.
    079         *
    080         * @throws CloneNotSupportedException if the rule is not clonable.
    081         */
    082        public Object clone() throws CloneNotSupportedException {
    083            return super.clone();
    084        }
    085
    086    }